/*
	FW2.00 laodcore.prx patcher
*/

#include <pspkernel.h>
#include <pspdebug.h>
#include <stdio.h>
#include "patch.h"

//#define MONITOR_PROBE

extern void sceKernelDcacheWBinvAll(void);
extern void sceKernelIcacheClearAll(void);

extern unsigned int sceUtilsGetLoadModuleABLength;
extern unsigned int memlmd_Unkonow_185f0a2a;
extern unsigned int sceKernelProbeExecutableObject;

/*****************************************************************************
 pb`̃LbVNA
*****************************************************************************/
void cache_clear(void)
{
	sceKernelDcacheWBinvAll();
	sceKernelIcacheClearAll();
}

/**************************************************************************:
	psar dumper
**************************************************************************/
extern int MyDecryptPRX(const u8* pbIn, u8* pbOut, int cbTotal, u32 tag);
extern int InitSysEntries(void);


#ifdef MONITOR_PROBE
/****************************************************************************
  CheckExecparam\
****************************************************************************/
static void show_prx_data(int *data)
{
#if 1
	int i;
	Kprintf("PRX data\n");
	for(i=0;i<0xe0/4;i++)
	{
		if( (i%4)==0)
			Kprintf("D %02X:",i*4);
		if( (i%4)==3)
			Kprintf("%08X\n",data[i]);
		else
			Kprintf("%08X ",data[i]);
	}
#endif
}

static void show_module_param(int *param)
{
#if 1
	int i;
	Kprintf("Module Info\n");
	for(i=0;i<0xc4/4;i++)
	{
		if( (i%4)==0)
			Kprintf("Param %02X:",i*4);
		if( (i%4)==3)
			Kprintf("%08X\n",param[i]);
		else
			Kprintf("%08X ",param[i]);
	}
	Kprintf("\n");
#endif
}
#endif

/**************************************************************************:
	trap
**************************************************************************/
#ifdef MONITOR_PROBE
int (*trap_return)(int *,int *,int *);
extern int trap_func(int *data,int *param,int arg3)

{
	int result;
	Kprintf("trap(%08X,%08X,%08X)\n",(int)data,(int)param,arg3);
	show_prx_data(data);
	show_module_param(param);
	result = trap_return(data,param,arg3);
	Kprintf("trap result %08X\n",result);
	return result;
}
#endif

/**************************************************************************:
	HOOK decrypt func
**************************************************************************/

int hook_sceUtilsGetLoadModuleABLength(unsigned char *prx_data,int size,int *readed)
{
	int i;
	int memid;
	int result;
	u32 tag = *(u32*)&prx_data[0xD0];
	u8 *tmp_buf;

	Kprintf("hook_sceUtilsGetLoadModuleABLength(%08X,%08X,%08X)\n",(int)prx_data,size,(int)readed);
	Kprintf("~PSP Module Name '%s' / TAG %08X\n",&prx_data[0x0a],tag);

	for(i=0;i<4;i++)
	{
		memid =  sceKernelAllocPartitionMemory(i, "decrypt_tmp",PSP_SMEM_High, size, NULL);
		if(memid>=0) goto mem_ok;
	}
	// err
	Kprintf("can't allocate decrypt tmp buffer\n");
	return -1;
mem_ok:

	tmp_buf = (u8 *)sceKernelGetBlockHeadAddr(memid);
//	Kprintf("decrypt tmp buffer = %d %08X\n",i,(int)tmp_buf);

	result = MyDecryptPRX(prx_data,tmp_buf,size, tag);
	Kprintf("result %d\n",result);

	if(result>0)
	{
		// OK , copy data
		*readed = result;
		memcpy( prx_data, tmp_buf , result);
		result = 0;
	}

	sceKernelFreePartitionMemory(memid);
	return result;
}

/**************************************************************************:

	FW 2.0 plain prx load patcher

**************************************************************************/
int prx20_install(void)
{
	u32 *addr;
//	u32 devkit_ver = 0x03000000;

	if (!InitSysEntries())
	{
		Kprintf("PSAR 02b can't installed\n");
		return -1;
	}

	addr = (u32*) (0x80000000 | ((sceUtilsGetLoadModuleABLength & 0x03FFFFFF) << 2));
	Kprintf("hook sceUtilsGetLoadModuleABLength = %08X\n",(int)addr);
	addr[0] = MIPS_J(hook_sceUtilsGetLoadModuleABLength);
	addr[1] = MIPS_NOP;

	addr = (u32*) (0x80000000 | ((memlmd_Unkonow_185f0a2a & 0x03FFFFFF) << 2));
	Kprintf("hook memlmd_Unkonow_185f0a2a = %08X\n",(int)addr);
	addr[0] = MIPS_J(hook_sceUtilsGetLoadModuleABLength);
	addr[1] = MIPS_NOP;

#if 0
	// deckit version
	addr = (u32*) (0x80000000 | (( ((u32)sceKernelDevkitVersion) & 0x03FFFFFF) << 2));
	addr[0] = MIPS_LUI(2,devkit_ver>>16);
	addr[1] = MIPS_JR(31);
	addr[2] = MIPS_ORI(2,2,devkit_ver&0xffff);
#endif

#ifdef MONITOR_PROBE
/*
  jal    $00003E78                          ;00003A8C[0C000F9E,'....']
*/
	// monitor
	addr = (u32*) (0x80000000 | (( ((u32)sceKernelProbeExecutableObject) & 0x03FFFFFF) << 2));
	addr -= (0x00002F48/4);

//	trap_return = (void *)&addr[0x00003E78/4];
//	addr[0x00003A8C/4] = MIPS_JAL(trap_func);
/*
  jal    $00003AA4                          ;00003A58[0C000EA9,'....']
*/
//	trap_return = (void *)&addr[0x00003AA4/4];
//	addr[0x00003A58/4] = MIPS_JAL(trap_func);
/*
  jal    sceKernelCheckExecFile             ;00003118[0C000B27,''...']
*/
//	trap_return = (void *)&addr[0x00002C9C/4];
//	addr[0x00003118/4] = MIPS_JAL(trap_func);

/*
  jal    $00004210                          ;00002EA8[0C001084,'....']
*/
//	trap_return = (void *)&addr[0x00004210/4];
//	addr[0x00002EA8/4] = MIPS_JAL(trap_func);

/*
  jal    $00004490                          ;00004410[0C001124,'$...']
*/
	trap_return = (void *)&addr[0x00004490/4];
	addr[0x00004410/4] = MIPS_JAL(trap_func);


/*
  jal    sceUtilsGetLoadModuleABLength      ;000028A4[0C001911,'....']
  jal    sceUtilsGetLoadModuleABLength      ;00004600[0C001911,'....']
L00006444:

  jal    memlmd_Unkonow_185f0a2a            ;00004628[0C001913,'....']
L0000644C:
*/

#endif

	cache_clear();






/*
mesg_led
;-------------------------------------------------------------------
;   decrypt core
;
;arg1:pointer of SUB code : pointer of header[0x0d0] compare code (4bytes)
;arg2:pointer of fixed decrypt table (size=0x90h)
;arg3:decrypt KEY CODE
;arg4:pdata  ~PSP
;arg5:size
;arg6:work pointer (sp)
;arg7:mode 0 = INT(ABlength) , 1 = POLL(decrypt)
;arg8:pointer of ? data ( arg2 of $0000006C)
;-------------------------------------------------------------------
;
L00000128:

memlmd
;-------------------------------------------------------------------
;   decrypt core
;
; ~PSPňÍꂽ prxW[ǂ
; k𓀂͍sȂ
; 
;arg1:pdata  ~PSP
;arg2:data size
;arg3:work pointer(sp)
;arg4:mode 0 = INT(ABlength) , 1 = POLL(decrypt)
;-------------------------------------------------------------------
L00000128:

*/

	return 0;
}
